/*
	ftppw 0.1
	coded by evilgoat
	http://wintermarket.org:81/~evilgoat/
	03/11/02 18:38

	if you make modifications to this source please give back to the community
	by sharing your modifications at http://wintermarket.org:81/~evilgoat/cgi-bin/yabb/YaBB.pl?board=source
	or email evilgoat@goats.org.au
*/

#include <windows.h>
#include <stdio.h>
#include <winsock.h>
#include "includes.h"


int net_send(int sock, char *fmt, ...) {
	char *data;
	int i;
    va_list args;
    data = (char *)malloc(4096);
    memset(data, 0, 4096);

    va_start(args, fmt);
    vsprintf(data, fmt, args);
    va_end(args);

    i = send(sock, data, strlen(data), 0);
#ifdef CONSOLE_OUT
	con_out("net_send(): (%04d) TX: %s", sock, data);
#endif
	free(data);
	return i;
}

int net_read(int sock, char *buf, int len) {
	char ch;
	int i, rd = 0;

	while (rd<len - 1) {
		i = recv(sock, &ch, 1, 0);
 		if (i == 0 || i == SOCKET_ERROR)
		{
#ifdef CONSOLE_OUT
            con_out("net_read(): (%04d) connection closed\n", sock);
#endif
            net_close(sock);
            return -1;
		}

		if (ch == '\n' && rd >=1) {
			break;
		}
		buf[rd++] = ch;
	}
	buf[rd-1]=0;
#ifdef CONSOLE_OUT
    con_out("net_read(): (%04d) RX: %s\n", sock, buf);
#endif
	return rd;
}

int net_close(int socket) {
	closesocket(socket);
	socket = -1;
	return 0;
}

int net_xfer_file(struct sockaddr_in* addr, struct xfer_s *xfs) {
	BOOL reuseaddr;
	struct sockaddr_in server_addr;
	int ret;
	fd_set fds;
	struct timeval tv;
#ifdef CONSOLE_OUT
	con_out("net_xfer_file(): filename: %s, filepos: %d, tmpfile: %d\n", xfs->filename, xfs->filepos, xfs->tmpfile);
#endif
	if(xfs->pasv_sock==INVALID_SOCKET) {
		*xfs->data_sock = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP);

		reuseaddr = TRUE;
		setsockopt(*xfs->data_sock,SOL_SOCKET,SO_REUSEADDR,(char*)&reuseaddr,sizeof(reuseaddr));

		memset(&server_addr, 0, sizeof(server_addr));

		server_addr.sin_family = AF_INET;
		server_addr.sin_port = htons(atoi(opt.opt_port)-1);
		server_addr.sin_addr.s_addr = INADDR_ANY;

		bind(*xfs->data_sock, (struct sockaddr *)&server_addr, sizeof(server_addr));

		ret = connect(*xfs->data_sock, (struct sockaddr *)addr, sizeof(struct sockaddr_in));
		if (ret != 0) {
#ifdef CONSOLE_OUT
			con_out("connect() failed\n");
#endif
			return -1;
		}
	} else { // pasv
		tv.tv_sec = 30;
		tv.tv_usec = 0;

		FD_ZERO(&fds);
		FD_SET(xfs->pasv_sock, &fds);

		ret = select(xfs->pasv_sock+1, &fds, 0, 0, &tv);
#ifdef CONSOLE_OUT
		if (ret == -1)
			con_out("no select\n");
#endif
		*xfs->data_sock = accept(xfs->pasv_sock, 0, 0);
#ifdef CONSOLE_OUT
		if (*xfs->data_sock == -1)
			con_out("no accept\n");
#endif
	}
	if (xfs->sending) {
		long id;
		CreateThread(0, 0, net_send_file, xfs, 0, &id);
  	} else if (!xfs->sending) {
		long id;
		CreateThread(0, 0, net_recv_file, xfs, 0, &id);
  	}
  	return 0;
}

DWORD WINAPI net_send_file(void *p) {
	HANDLE hFile;
	long total, read;
	char buffer[1024];
	char olddir[MAX_PATH+1];
	int ret, data_sock;
	struct xfer_s *xf_s;
	xf_s = (struct xfer_s *)p;

	GetCurrentDirectory(128, olddir);
	SetCurrentDirectory(xf_s->cwd);
	hFile = CreateFile(xf_s->filename, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
	if (hFile == INVALID_HANDLE_VALUE) {
#ifdef CONSOLE_OUT
		con_out("net_send_file(): couldnt open file\n");
#endif
		net_send(xf_s->ctrl_sock, "550 File not found.\r\n");
		return -1;
   	}
	SetCurrentDirectory(olddir);
	ret = SetFilePointer(hFile, xf_s->filepos, NULL, FILE_BEGIN);
#ifdef CONSOLE_OUT
	con_out("net_send_file(): new fpos = %d\n", ret);
#endif
   	total=0;
	data_sock = *xf_s->data_sock;

   	do {
   		ReadFile(hFile, buffer, 1024, &read, NULL);
   		ret = send(data_sock, buffer, read, 0);
   		if ((ret == 0) || (ret == -1)) {
			break;
		}
   		total+=ret;
   	} while (read > 0);

   	net_send(xf_s->ctrl_sock, "226 Download Complete, %d bytes sent.\r\n", total);
	CloseHandle(hFile);
   	if (xf_s->tmpfile) {
   	    DeleteFile(xf_s->filename);
    }
	net_close(data_sock);
    return 0;
}

DWORD WINAPI net_recv_file(void *p) {
	HANDLE hFile;
	long total, read, written;
	char buffer[1024];
	char olddir[MAX_PATH+1];
	struct xfer_s *xf_s;
	xf_s = (struct xfer_s *)p;

	fronttoback(xf_s->filename);
#ifdef CONSOLE_OUT
   	con_out("%s\n", xf_s->filename);
#endif
	GetCurrentDirectory(128, olddir);
	SetCurrentDirectory(xf_s->cwd);
    hFile = CreateFile(xf_s->filename, GENERIC_WRITE, 0, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
	SetCurrentDirectory(olddir);
    SetFilePointer(hFile, xf_s->filepos, NULL, FILE_BEGIN);
	do {
		read = recv(*xf_s->data_sock, buffer, 1024, 0);
		WriteFile(hFile, buffer, read, &written, 0);
		total+=written;
	} while (read > 0);
   	closesocket(*xf_s->data_sock);
   	net_send(xf_s->ctrl_sock, "226 Upload Complete, %d bytes sent.\r\n", total);
	CloseHandle(hFile);
	return 0;
}

